package unavailableconnapp.view.bean;

import oracle.adf.controller.TaskFlowId;
import oracle.adf.controller.metadata.MetadataService;
import oracle.adf.controller.metadata.model.TaskFlowDefinition;
import oracle.adf.controller.metadata.model.TransactionType;

public class TaskFlowInfoBean
{
	public static final TaskFlowId ID_TWO_APP_MOD_BTF =
		TaskFlowId.parse("WEB-INF/btf/two-app-mod-btf.xml#two-app-mod-btf");

	public String getTwoAppModBTFTransactionTypeName()
	{
		return getTaskFlowTransactionTypeName(ID_TWO_APP_MOD_BTF);
	}

	public static String getTaskFlowTransactionTypeName(TaskFlowId pTaskFlowId)
	{
		MetadataService vMetadataService = MetadataService.getInstance();
		if (pTaskFlowId == null)
		{
			return "(no TaskFlowId)";
		}
		TaskFlowDefinition vTaskFlowDefinition =
			vMetadataService.getTaskFlowDefinition(pTaskFlowId);
		if (vTaskFlowDefinition != null)
		{
			TransactionType vTransactionType = vTaskFlowDefinition.getTransactionType();
			
			if (vTransactionType == null)
			{
				return "-No Controller Transaction-";
			}
			else if (vTransactionType == TransactionType.NEW_TRANSACTION)
			{
				return "Always Begin New Transaction";
			}
			else if (vTransactionType == TransactionType.REQUIRES_EXISTING_TRANSACTION)
			{
				return "Always Use Existing Transaction";
			}
			else if (vTransactionType == TransactionType.REQUIRES_TRANSACTION)
			{
				return "Use Existing Transaction if Possible";
			}
			else
			{
				return "unknown TransactionType (" + vTransactionType + ")";
			}
		}
		else
		{
			return "(no TaskFlowDefinition)";
		}
	}
}
